#include "mdd.h"

void addition_block_build (), one_var_and_carry_add_block ();


void
addition_block_build( mgr, A, B ,bx_ptr, by_ptr, bz_ptr)
mdd_manager *mgr;
mdd_t **A, 
      **B;
bvar_type *bx_ptr,
	  *by_ptr,
          *bz_ptr;

{
	mdd_t *zero;
	mdd_t 	*C, *D, *E, *F,
		*G, *H, *I;

	zero = mdd_zero(mgr);	
		
	G = mdd_ite( by_ptr->node, zero , *A  ,  1, 1, 1 );
	H = mdd_ite( by_ptr->node, *A   , *B  ,  1, 1, 1 );
	I = mdd_ite( by_ptr->node, *B   , zero,  1, 1, 1 );

	C = mdd_ite( bx_ptr->node, zero, G   ,  1, 1, 1 );
	D = mdd_ite( bx_ptr->node, G   , H   ,  1, 1, 1 );
	E = mdd_ite( bx_ptr->node, H   , I   ,  1, 1, 1 );
	F = mdd_ite( bx_ptr->node, I   , zero,  1, 1, 1 );
		
	*A = mdd_ite( bz_ptr->node, D   , C   ,  1, 1, 1 );
	*B = mdd_ite( bz_ptr->node, F   , E   ,  1, 1, 1 );

	mdd_free(G);
	mdd_free(H);
	mdd_free(I);
	mdd_free(C);
	mdd_free(D);
	mdd_free(E);
	mdd_free(F);
	mdd_free(zero);

	return;
}


void
one_var_and_carry_add_block(mgr, A, B, bz_ptr, blv_ptr)
mdd_manager *mgr;
mdd_t **A,
      **B;
bvar_type *bz_ptr,
          *blv_ptr;
{
	mdd_t *C, *D, *E;
	mdd_t *zero;

	zero = mdd_zero(mgr);	

	C = mdd_ite( blv_ptr->node,  zero,   *A, 1, 1, 1);
	D = mdd_ite( blv_ptr->node,    *A,   *B, 1, 1, 1);
	E = mdd_ite( blv_ptr->node,    *B, zero, 1, 1, 1);

	*A = mdd_ite( bz_ptr->node,    D, C, 1, 1, 1);
	*B = mdd_ite( bz_ptr->node, zero, E, 1, 1, 1);

	mdd_free(C);
	mdd_free(D);
	mdd_free(E);

	mdd_free(zero);

	return;
}




mdd_t *
mdd_add_s( mgr, sum_id, mvar_id1, mvar_id2 ) /* in1 + in2 = sum */
mdd_manager *mgr;
int sum_id,
    mvar_id1,
    mvar_id2;
{
	mdd_t *one, *zero;
	array_t *mvar_list;
 	array_t *bvar_list;
	bdd_external_hooks *hook;
	int 	z_carry_index, config, 
	    	no_common_to_all_bits, 
	   	no_common_in_bits, i,
		long_var_index;
	bvar_type bx, by, bz, z_carry, blv;
	mvar_type x, y, z, long_var, short_var;
	mdd_t 	*A, *B, *result, *range_check;
	

	
	hook =  bdd_get_external_hooks(mgr);
	mvar_list = ((mdd_hook_type *)(hook->mdd))->mvar_list;    
	bvar_list = ((mdd_hook_type *)(hook->mdd))->bvar_list;    
	
	x = array_fetch(mvar_type, mvar_list, mvar_id1);
	y = array_fetch(mvar_type, mvar_list, mvar_id2);
	z = array_fetch(mvar_type, mvar_list, sum_id);

	/* Ensures that the i_th bit of x has smaller index
	   than the i_th bit of y */

	if  ( (x.start_vertex + (x.encode_length-1)*x.stride ) >
              (y.start_vertex + (y.encode_length-1)*y.stride )  )  {
			y = array_fetch(mvar_type, mvar_list, mvar_id1);
			x = array_fetch(mvar_type, mvar_list, mvar_id2);
			}

	one = mdd_one(mgr);
	zero = mdd_zero(mgr);	
	
	no_common_in_bits = MIN(x.encode_length,y.encode_length);
	no_common_to_all_bits = MIN(no_common_in_bits, z.encode_length);

	A = mdd_dup(one);
	B = mdd_dup(zero);

	for (i = 1; i <= no_common_to_all_bits; i++){

		bx = array_fetch(bvar_type, bvar_list,
				x.start_vertex + (x.encode_length-i) * x.stride );
		by = array_fetch(bvar_type, bvar_list,
				y.start_vertex + (y.encode_length-i) * y.stride );
		bz = array_fetch(bvar_type, bvar_list,
				z.start_vertex + (z.encode_length-i) * z.stride );

		addition_block_build( mgr, &A, &B, &bx, &by, &bz);
	}


	if ( z.encode_length > no_common_to_all_bits ){
		if ( x.encode_length != y.encode_length ){
			if ( x.encode_length == no_common_in_bits ){ 
				long_var = y;   
				short_var = x;
			}
			else { 
				long_var = x;   
				short_var = y;
			}
		
			if ( z.encode_length > long_var.encode_length) {
			config = 1;	 
			}
			else
			{
			config = 2;		
			}
		}
		else 
			config = 3;			
	}
	else 
		config = 4;			


	switch (config) {
		
		case 1: /* z > long_var , short_var */
			z_carry_index = z.start_vertex + (z.encode_length - no_common_to_all_bits ) * z.stride;
			long_var_index = long_var.start_vertex + 
						(long_var.encode_length - no_common_to_all_bits ) * long_var.stride;

			for ( i = no_common_to_all_bits + 1; i <= long_var.encode_length; i++){

				z_carry_index -= z.stride;
				long_var_index -= long_var.stride;

				z_carry = array_fetch(bvar_type, bvar_list, z_carry_index);							
				blv = array_fetch(bvar_type, bvar_list, long_var_index);							

				one_var_and_carry_add_block(mgr, &A, &B, &bz, &blv);

			}
			

			z_carry_index -= z.stride;
			z_carry = array_fetch(bvar_type, bvar_list, z_carry_index);							
			A = mdd_ite( z_carry.node, B, A, 1, 1, 1);

			for ( i = long_var.encode_length + 2; i <= z.encode_length; i++){
				z_carry_index -= z.stride;
				z_carry = array_fetch(bvar_type, bvar_list, z_carry_index);							
				A = mdd_ite( z_carry.node, zero, A, 1, 1, 1);				
			}
			result = mdd_dup(A);
			break;

		case 2: /* short_var < z < long_var */
			z_carry_index = z.start_vertex + (z.encode_length - no_common_to_all_bits ) * z.stride;
			long_var_index = long_var.start_vertex + 
						(long_var.encode_length - no_common_to_all_bits ) * long_var.stride;

			for ( i = no_common_to_all_bits + 1; i <= z.encode_length; i++){

				z_carry_index -= z.stride;
				long_var_index -= long_var.stride;

				z_carry = array_fetch(bvar_type, bvar_list, z_carry_index);							
				blv = array_fetch(bvar_type, bvar_list, long_var_index);							

				one_var_and_carry_add_block(mgr, &A, &B, &bz, &blv);

			}

			result = mdd_or(A,B,1,1);
			break;

		case 3: /* z> long_var = short_var */ 

			z_carry_index = z.start_vertex + (z.encode_length - no_common_to_all_bits - 1) * z.stride;
			z_carry = array_fetch(bvar_type, bvar_list, z_carry_index);							
			A = mdd_ite( z_carry.node, B, A, 1, 1, 1);

			for ( i = no_common_to_all_bits + 2; i <= z.encode_length; i++){
				z_carry_index -= z.stride;
				z_carry = array_fetch(bvar_type, bvar_list, z_carry_index);							
				A = mdd_ite( z_carry.node, zero, A, 1, 1, 1);
			}	

			result = mdd_dup(A);
			break;

		case 4: /* z <= long_var, z <= short_var */
			result = mdd_or(A,B,1,1);
			break;
	}
	
	mdd_free(A);
	mdd_free(B);


	mdd_free(one);
	mdd_free(zero);
	
	range_check = build_lt_c(mgr, sum_id, z.values);
	result = mdd_and(result, range_check, 1, 1);

	mdd_free(range_check);

	return result;
}
