#include "mdd.h"

int
mdd_bundle_variables( mgr, bundle_vars, mdd_var_name, mdd_id )
mdd_manager *mgr;
array_t *bundle_vars;
char *mdd_var_name;
int *mdd_id;
{
	array_t *mvar_list, *bvar_list, *bundle_mvars, *new_mvar_list;
	int diff = 0, old_diff = 0;
	mvar_type var_i, var_ip1, new_var, var_0, mvar_i;
	int i, j, k, index_i, to_be_deleted;
	bvar_type *bit_j_ptr, *bit_k_ptr;
	char name[20];
	
	mvar_list = mdd_ret_mvar_list(mgr);
	bvar_list = mdd_ret_bvar_list(mgr);

	bundle_mvars = array_alloc( mvar_type, 0);

	for(i=0; i<array_n(bundle_vars); i++) {
		index_i = array_fetch( int, bundle_vars, i);
		mvar_i = array_fetch( mvar_type, mvar_list, index_i );
		array_insert_last( mvar_type, bundle_mvars, mvar_i );
	}

	if ( array_n(bundle_mvars) > 1 ){

		var_i = array_fetch( mvar_type, bundle_mvars, 0);
		var_ip1 = array_fetch( mvar_type, bundle_mvars, 1); 
		old_diff = var_ip1.start_vertex - var_i.start_vertex;
	
		for(i=1; i<array_n(bundle_mvars)-1; i++){
			var_i = array_fetch( mvar_type, bundle_mvars, i);
			var_ip1 = array_fetch( mvar_type, bundle_mvars, i+1); 
			diff = var_ip1.start_vertex - var_i.start_vertex;
			if (diff != old_diff) return FALSE; /* Variables not interleaved properly */
			}
	}

	new_var.stride = old_diff;

	var_0 = array_fetch( mvar_type, bundle_mvars, 0);

	new_var.mvar_id = array_n(mvar_list) - array_n(bundle_vars); /* Add variable to the end of mvar_list */
	*mdd_id = new_var.mvar_id;

	if ( mdd_var_name != NIL( char ) )  
		new_var.name = mdd_var_name;
	else {
		sprintf(name,"mv_%d", new_var.mvar_id);
		new_var.name = name;
	};

	new_var.encode_length = array_n(bundle_mvars);

	new_var.start_vertex = var_0.start_vertex;
	new_var.encoding = ALLOC(int, new_var.encode_length);

	new_var.values = 1;
	for(i=0; i< array_n(bundle_mvars); i++){
		var_i = array_fetch( mvar_type, bundle_mvars, i);
		new_var.values *= var_i.values;
	}

	array_insert_last( mvar_type, mvar_list, new_var);

	new_mvar_list = array_alloc( mvar_type, 0);

	to_be_deleted = var_0.mvar_id;
	j = 0;

	for (i=0; i<array_n(mvar_list); i++) {

		if ( i != to_be_deleted ) {
			mvar_i = array_fetch( mvar_type, mvar_list, i);
			mvar_i.mvar_id = array_n(new_mvar_list);
			for (k=0; k<mvar_i.encode_length; k++) {
				bit_k_ptr = array_fetch_p(bvar_type, bvar_list, mvar_i.start_vertex+ (k*mvar_i.stride) );
				bit_k_ptr->mvar_id = mvar_i.mvar_id;
			}
			array_insert_last( mvar_type, new_mvar_list, mvar_i );
		}

		else {
			if (j<(array_n(bundle_vars)-1) ) 
				j++;
			to_be_deleted = array_fetch( int, bundle_vars, j);
		}
	}

	for (i=0; i<array_n(bundle_vars); i++) {
		mvar_i = array_fetch(mvar_type, bundle_mvars, i);
		FREE( mvar_i.name );
		FREE( mvar_i.encoding );
	};

	array_free( mvar_list );

	mdd_set_mvar_list(mgr, new_mvar_list);
	array_free( bundle_mvars );

	return TRUE;

}
