#include "mdd.h"

/*
 * MDD Package
 * /projects/hsis/CVS/utilities/mdd/mdd_consensus.c,v
 *
 * Author: Timothy Kam
 * 1993/08/03 22:38:10
 * 1.2
 *
 * Copyright 1992 by the Regents of the University of California.
 *
 * All rights reserved.  Permission to use, copy, modify and distribute
 * this software is hereby granted, provided that the above copyright
 * notice and this permission notice appear in all copies.  This software
 * is made available as is, with no warranties.
 */

mdd_t *
mdd_consensus(mgr, fn, mvars)
mdd_manager *mgr;
mdd_t *fn;
array_t *mvars;
{
    array_t *bdd_vars;
    int i, j, mv_no, num, mv_last;
    mvar_type mv;
    mdd_t *top;
	bdd_t *tmp;
    array_t *mvar_list;
    bdd_external_hooks *hook;

    hook =  bdd_get_external_hooks(mgr);
    mvar_list = ((mdd_hook_type *)(hook->mdd))->mvar_list;                                                                                

    bdd_vars = array_alloc(bdd_t *, 0);
    for (i=0; i<array_n(mvars); i++) {
        mv_no = array_fetch(int, mvars, i);
	mv = array_fetch(mvar_type, mvar_list, mv_no);
	mv_last = mv.start_vertex + mv.stride*mv.encode_length; 
        for (j = mv.start_vertex;
             j < mv_last;
             j += mv.stride) {
		tmp = bdd_get_variable(mgr, (unsigned int)j);
	    array_insert_last(bdd_t *, bdd_vars, tmp);
	}
    }
    top = bdd_consensus(fn, bdd_vars);
	num = array_n(bdd_vars);
	for(i=0; i<num; i++){
		bdd_free(array_fetch(bdd_t *, bdd_vars, i));
	}
    array_free(bdd_vars);
    return top;
}
