#include "mdd.h"

/*
 * MDD Package
 * /projects/hsis/CVS/utilities/mdd/mdd_eq_s.c,v
 *
 * Author: Timothy Kam
 * 1993/08/03 22:38:14
 * 1.2
 *
 * Copyright 1992 by the Regents of the University of California.
 *
 * All rights reserved.  Permission to use, copy, modify and distribute
 * this software is hereby granted, provided that the above copyright
 * notice and this permission notice appear in all copies.  This software
 * is made available as is, with no warranties.
 */

void 
bdd_cubes_print(fn)
bdd_t *fn;
{
    bdd_gen *gen;
    array_t *cube;
    int i;
    bdd_literal literal;
    boolean header;

    /* assert( ! fn->free ) ; */
/*    header = FALSE; */
    header = TRUE;
    foreach_bdd_cube(fn, gen, cube) {
      if (array_n(cube) >= 500) {
	printf("bdd_cubes_print: BDD not printed, too many variables.\n");
	(void) bdd_gen_free(gen);
	return;
      } else {
#if !REVERSE_PRINT
	if (!header) {
	    if (array_n(cube) >= 10) {
	        for (i=0; i<array_n(cube); i++) 
			printf("%d", i/10);
		printf("\n");
	    }
	    for (i=0; i<array_n(cube); i++) 
		printf("%d", i%10);
	    printf("\n");
	    for (i=0; i<array_n(cube); i++) 
		printf("=");
	    printf("\n");
	    header = TRUE;
	}
	for (i=0; i<array_n(cube); i++) {
	    literal = array_fetch(bdd_literal, cube, i);
	    if (literal != 2) {
	        (void) printf("%d",literal);
	    }
	    else {
		(void) printf("-");
	    }
	}
	(void) printf("\n");
#else
        if (!header) {
            if (array_n(cube) >= 10) {
	        for (i = array_n(cube)-1; i >= 0; i--)
                        printf("%d", i/10);
                printf("\n");
            }
	    for (i = array_n(cube)-1; i >= 0; i--)
                printf("%d", i%10);
            printf("\n");
            for (i=0; i<array_n(cube); i++)
                printf("=");
            printf("\n");
            header = TRUE;
        }
        for (i = array_n(cube)-1; i >= 0; i--) {
            literal = array_fetch(bdd_literal, cube, i);
            if (literal != 2) {
                (void) printf("%d",literal);
            }
            else {
                (void) printf("-");
            }
        }
        (void) printf("\n");
#endif
      }
    }
    /* (void) printf("\n"); */
}


mdd_t *
mdd_eq_s(mgr, mvar1, mvar2)
mdd_manager *mgr;
int mvar1, mvar2;
{
/*
mvar_type x, y;
    bvar_type bx, by;
    mdd_t *t, *tt, *ttb;
    mdd_t *x_is_dont_care_or_max_val,
	  *y_is_dont_care_or_max_val,
	  *both_are_dont_cares_or_max_val;

    int i;
    array_t *mvar_list;
    array_t *bvar_list;
    bdd_external_hooks *hook;
    mdd_t *zero;
    int virtual_range;


    hook =  bdd_get_external_hooks(mgr);
    mvar_list = ((mdd_hook_type *)(hook->mdd))->mvar_list;    
    bvar_list = ((mdd_hook_type *)(hook->mdd))->bvar_list;    
    
    zero = mdd_zero(mgr);

    x = array_fetch(mvar_type, mvar_list, mvar1);
    y = array_fetch(mvar_type, mvar_list, mvar2);
    if (x.values != y.values) 
	fail("mdd_fast_lt: 2 mvars have incompatible value ranges\n");

    t = mdd_one(mgr);
    for (i=(x.encode_length-1); i>=0; i--) {
	bx = array_fetch(bvar_type, bvar_list, x.start_vertex + i*x.stride);
	by = array_fetch(bvar_type, bvar_list, y.start_vertex + i*y.stride);
	ttb = mdd_ite(by.node, zero, t, 1, 1, 1);
	tt  = mdd_ite(by.node, t, zero, 1, 1, 1);
	mdd_free(t);
	t = mdd_ite(bx.node, tt, ttb, 1, 1, 1);
        mdd_free(tt);
	mdd_free(ttb);
    }

     bdd_cubes_print(t);
    virtual_range = (int) ( pow(2.0, (double)x.encode_length));
    if (x.values < virtual_range) {
	x_is_dont_care_or_max_val = build_geq_c(mgr, mvar1, x.values - 1);
	bdd_cubes_print(x_is_dont_care_or_max_val);
	y_is_dont_care_or_max_val = build_geq_c(mgr, mvar2, y.values - 1);
	
	both_are_dont_cares_or_max_val = mdd_and(x_is_dont_care_or_max_val, y_is_dont_care_or_max_val, 1, 1);
	bdd_cubes_print(both_are_dont_cares_or_max_val);
	t = bdd_or( t, both_are_dont_cares_or_max_val, 1, 1);
	     bdd_cubes_print(t);

	}

    mdd_free(zero);
    t = mdd_eq(mgr,mvar1,mvar2);
     bdd_cubes_print(t);

    if (mdd_equal(mdd_eq(mgr,mvar1,mvar2),t)==0) printf("ERRRORRR\n");
*/
    return mdd_eq(mgr,mvar1,mvar2);
}
