#include "mdd.h"

/*
 * MDD Package
 * /projects/hsis/CVS/utilities/mdd/mdd_quit.c,v
 *
 * Author: Timothy Kam
 * 1993/08/03 22:39:18
 * 1.2
 *
 * Copyright 1992 by the Regents of the University of California.
 *
 * All rights reserved.  Permission to use, copy, modify and distribute
 * this software is hereby granted, provided that the above copyright
 * notice and this permission notice appear in all copies.  This software
 * is made available as is, with no warranties.
 */

void
mdd_quit(mgr)
mdd_manager *mgr;
{
    int i;
    mvar_type one_mvar_struct;
    array_t *mvar_list;
    array_t *bvar_list;
    bdd_external_hooks *hook;

    hook =  bdd_get_external_hooks(mgr);
    mvar_list = ((mdd_hook_type *)(hook->mdd))->mvar_list;                                                                                
    bvar_list = ((mdd_hook_type *)(hook->mdd))->bvar_list;                                                                                

    for (i=0; i<array_n(mvar_list); i++) {
        /* Paul and Huey-Yih don't like this:
		mv_ptr = &array_fetch(mvar_type, mvar_list, i); */
	one_mvar_struct = array_fetch(mvar_type, mvar_list, i);
        FREE(one_mvar_struct.name);
        FREE(one_mvar_struct.encoding);
    }
    array_free(mvar_list); 
    array_free(bvar_list); 

    bdd_end(mgr);
}
