#include "mdd.h"

/*
 * MDD Package
 * /projects/hsis/CVS/utilities/mdd/mdd_smooth.c,v
 * 
 * Author: Timothy Kam
 * 1993/08/03 22:39:25
 * 1.2
 *
 * Copyright 1992 by the Regents of the University of California.
 *
 * All rights reserved.  Permission to use, copy, modify and distribute
 * this software is hereby granted, provided that the above copyright
 * notice and this permission notice appear in all copies.  This software
 * is made available as is, with no warranties.
 */

mdd_t *
mdd_smooth(mgr, fn, mvars)
mdd_manager *mgr;
mdd_t *fn;
array_t *mvars;
{
    array_t *bdd_vars;
    int i, mv_no;
    unsigned int j;
    mvar_type mv;
    mdd_t *top;
    bdd_t *temp;
    array_t *mvar_list;
    bdd_external_hooks *hook;

    if ( mvars != NIL(array_t) ){
	if ( array_n(mvars) != 0 ) {
	    hook =  bdd_get_external_hooks(mgr);
	    mvar_list = ((mdd_hook_type *)(hook->mdd))->mvar_list;
	
	    bdd_vars = array_alloc(bdd_vars, 0);	/**** RAMIN ****/
	    for (i=0; i<array_n(mvars); i++) {
		mv_no = array_fetch(int, mvars, i);
		mv = array_fetch(mvar_type, mvar_list, mv_no);
		for (j = mv.start_vertex;
		     j < (mv.start_vertex + mv.stride*mv.encode_length);
		     j += mv.stride) {
		    temp = bdd_get_variable(mgr, j);
		    array_insert_last(bdd_t *, bdd_vars, temp);
		}
	    }
	top = bdd_smooth(fn, bdd_vars);
       }
	else {
	    top = bdd_dup( fn );
	    printf("\nWARNING: Empty Array of Smoothing Variables\n");
	};
    }
    else {
	top = bdd_dup( fn );
	printf("\nWARNING: Empty Array of Smoothing Variables\n");
    };
    for(i=0; i<array_n(bdd_vars); i++) {
        temp = array_fetch(bdd_t*,bdd_vars,i);
        bdd_free(temp);
    }
    array_free(bdd_vars);
    return top;
}
